---
title: WebGLRenderingContext.stencilMaskSeparate()
slug: Web/API/WebGLRenderingContext/stencilMaskSeparate
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.stencilMaskSeparate()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> controls enabling and disabling of front and/or back writing of individual bits in the stencil planes.</p>

<p>The {{domxref("WebGLRenderingContext.stencilMask()")}} method can set both, the front and back stencil writemasks to one value at the same time.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.stencilMaskSeparate(<var>face, <var>mask</var>);
</var></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>face</dt>
 <dd>A {{domxref("GLenum")}} specifying whether the front and/or back stencil writemask is updated. The possible values are:
 <ul>
  <li><code>gl.FRONT</code></li>
  <li><code>gl.BACK</code></li>
  <li><code>gl.FRONT_AND_BACK</code></li>
 </ul>
 </dd>
 <dt><code>mask</code></dt>
 <dd>A {{domxref("GLuint")}} specifying a bit mask to enable or disable writing of individual bits in the stencil planes. By default, the mask is all 1.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.stencilMaskSeparate(gl.FRONT, 110101);
</pre>

<p>To get the current stencil masks, query the <code>STENCIL_WRITEMASK</code>, <code>STENCIL_BACK_WRITEMASK</code>, or <code>STENCIL_BITS</code> constants.</p>

<pre class="brush: js">gl.getParameter(gl.STENCIL_WRITEMASK);
// 110101
gl.getParameter(gl.STENCIL_BACK_WRITEMASK);
// 110101
gl.getParameter(gl.STENCIL_BITS);
// 0
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "stencilMaskSeparate")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glStencilMaskSeparate.xml", "glStencilMaskSeparate")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.stencilMaskSeparate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.colorMask()")}}</li>
 <li>{{domxref("WebGLRenderingContext.depthMask()")}}</li>
 <li>{{domxref("WebGLRenderingContext.stencilMask()")}}</li>
</ul>
